mode2prefix =
  q: "~"
  a: "&"
  o: "@"
  h: "%"
  v: "+"

prefix2mode =
  ["~"]: "q"
  ["&"]: "a"
  ["@"]: "o"
  ["%"]: "h"
  ["+"]: "v"

convert = (mode_or_prefix) ->
  mode2prefix[mode_or_prefix] or prefix2mode[mode_or_prefix]

{
  :mode2prefix
  :prefix2mode
  :convert
}
